package Plugins::limelinx;

use strict;
use warnings;
use lib '..';
use lib '../Modules';
use Plugin;
use base 'Plugin'; 
use HTTP::Request::Common qw(POST GET);
use MIME::Base64;
use XML::Simple;
use Data::Dumper;
use vars qw($VERSION);

$VERSION = "1.6" ;

our $options = {
		plugin_id => 1034,
		plugin_prefix=>'ll',
		domain=>'limelinx.com',
		name=>'limelinx',
		can_login => 1,
		upload=>1,
		download=>1,
};

sub check_link {
	shift;
	my $link = shift;
	if ($link =~ /limelinx\.com/) {
		return 1;
	}
	return 0;
}

sub is_broken {
	my $self = shift;
	my $link = shift;
	$self->get($link);
	return 1 if($self->{content} =~ /this file has been removed/);
	return 0;
}

sub max_filesize {
	return 100*1024*1024;
}
sub login {
	my $self = shift;
	my $a = shift;
	return 1;
}


sub upload_file {
	my $self = shift;
	my $file = shift;
	my $filename = shift;
	my $description = shift;
	$self->{action} = 'upload';
	my $h = $self->getHT('http://limelinx.com/');
	my $form = $h->look_down('_tag', 'form', 'enctype'=>"multipart/form-data");
	my ($up_id) = $self->{content} =~ /var uploadId = '([A-Z0-9]+)/s;#'
	my ($action) = $form->{action};
	my $req = POST $action,
		Content_Type => "multipart/form-data",
		Content => ['Content[]'=>["$c->{filesdir}/$file", $filename], Agree=>1];
	$self->up_file($req);
	my $remove = '';
	my $link = '';
	$h = HTML::TreeBuilder->new_from_content($self->{content});
	$h->ignore_unknown(0);
	$h = $h->elementify();
	my $links = $h->look_down('_tag', 'a', 'class', 'InfoLink');
	if($links) {
		$link = $links->{href};
	}
	$h = $h->delete();
	return {download=>$link, remove=>$remove};
		
	
}
sub download {
	my $self = shift;
	my $url = shift;
	my $prefix = shift;
	my $update_stat = shift;
	my $req;
	my $response;
	my $dlink = '';
	$self->{action} = 'download';
	$req = GET $url;
	my $ff = $self->direct_download($req, $url, $prefix, $update_stat);
	if($ff->{type} =~ /html/) {
		my $h = $self->requestHT($req);
		my $li = $h->look_down('_tag', 'li', 'id','DownloadLI');
		my $a = $li->look_down('_tag', 'a');
		my $dlink = $a->{href};			
		$req = GET $dlink;
		my $ff = $self->direct_download($req, $url, $prefix, $update_stat);
		if($ff->{type} =~ /html/) {
			return {error=>-2, error_text=>'Cannot download direct link'};
		} 
	}
	return {error=>0, filename=>$ff->{filename}, filesize=>$ff->{filesize}};
	

}

1;
